#property copyright "Shinigami 2007-2010"
#property link      "shini1984@gmail.com"
extern int Takeprofit = 100;
extern int Stoploss = 100;
extern int RSI14_Value_Buy_Open  = 40;
extern int RSI14_Value_Buy_Close  = 60;
extern int RSI14_Value_Sell_Open = 60;
extern int RSI14_Value_Sell_Close  = 40;
extern int RSI5_Diff_Buy = 1;
extern int RSI5_Diff_Sell = 1;
extern int MaxBuys = 5;
extern int MaxSells = 5;
extern int MaxSumOrders = 0; // if 0, will be ignored, if more than 0, will be used instead both max buys and max sells
extern double    LotsIfNoMM=0.1;
extern bool      UseMM=false;
extern double    MMRiskFactor=0.05;
extern double    MMBalanceExcludeAmt=0;
extern double    MMBalanceShareDivisor=1;
extern int StartHour = 0;
extern int EndHour = 23;
int action;
datetime prev_time=0;
int MagicNumber=20070524;
string Comments="RSI_CROSS_BY_SHINIGAMI";


double CalculateMMLot()
  {
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
     {
      Print("CalculateMMLot: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
      return(0);
     }
   if(AccountLeverage()<=0)
     {
      Print("CalculateMMLot: invalid AccountLeverage() [",AccountLeverage(),"]");
      return(0);
     }
//--- basic formula
   lot=NormalizeDouble((AccountBalance()-MMBalanceExcludeAmt)/MMBalanceShareDivisor*MMRiskFactor/AccountLeverage()/10.0,2);
//--- additional calculation
//   ...
//--- check min, max and step
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
//---
   return(lot);
  }
  



int start()
{
int i,BuyOrders=0,SellOrders=0;
double Lots;
if (UseMM)
Lots=CalculateMMLot();
else
Lots=LotsIfNoMM;


if(TimeDay(StrToTime(TimeHour(iTime(NULL,0,0))+":00"))==TimeDay(iTime(NULL,0,0)))
 {
  if(iTime(NULL,PERIOD_M1,0)>=(StrToTime(StartHour+":00")))
   {
    if(iTime(NULL,PERIOD_M1,0)<=StrToTime(EndHour+":59"))
     {
      for(i=0;i<OrdersTotal();i++)
       {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderMagicNumber()==MagicNumber)
         {
          if(OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY)
            BuyOrders++;
            if(OrderType()==OP_SELL)
            SellOrders++;
           }
         }
       }
      if(BuyOrders<MaxOrders(BuyOrders,SellOrders,0))
       {
        if(iRSI(NULL,0,14,PRICE_CLOSE,1)<RSI14_Value_Buy_Open) //open buy where rsi is lower than some value
         {
          if(iRSI(NULL,0,14,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,2)) //and RSI is going up
           {
            if(iRSI(NULL,0,5,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,1)+RSI5_Diff_Buy) { //and rsi5 is higher n points
            OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,Comments,MagicNumber,0,Green); Sleep(1000); }
           }
         }
       }
      if(SellOrders<MaxOrders(BuyOrders,SellOrders,1))
       {
        if(iRSI(NULL,0,14,PRICE_CLOSE,1)>RSI14_Value_Sell_Open) //open Sell where rsi is higher than some value
         {
          if(iRSI(NULL,0,14,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,2)) //and RSI is going down
           {
            if(iRSI(NULL,0,5,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,1)+RSI5_Diff_Sell) { //and rsi5 is lower n points
            OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,Comments,MagicNumber,0,Green); Sleep(1000); }
           }
         }
       }
      for(i=0;i<OrdersTotal();i++)
       {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderMagicNumber()==MagicNumber)
         {
          if(OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY)
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Stoploss*Point,OrderOpenPrice()+Takeprofit*Point,0,Yellow);
            if(OrderType()==OP_SELL)
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Stoploss*Point,OrderOpenPrice()-Takeprofit*Point,0,Yellow);
           }
         }
       }
     } 
   }
 }
//////////////////// THAT IS IT FOR OPENING! NOW FOR CLOSING! ///////////////////////
   if(prev_time==iTime(NULL,PERIOD_M1,0))//we only make 1 check per minute!
           return(0);
   prev_time=iTime(NULL,PERIOD_M1,0);
for(i=0;i<OrdersTotal();i++)
 {
  OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
  if(OrderMagicNumber()==MagicNumber)
   {
    if(OrderSymbol()==Symbol())
     {
      if(OrderType()==OP_BUY)
       {
        if(iRSI(NULL,0,14,PRICE_CLOSE,1)>RSI14_Value_Buy_Close) //close buy when rsi is lower than some value
         {
          if(iRSI(NULL,0,14,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,2)) //and RSI is going down
           {
            if(iRSI(NULL,0,5,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,1)) //and rsi5 is lower
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);
           }
         }
       }
      if(OrderType()==OP_SELL)
       {
        if(iRSI(NULL,0,14,PRICE_CLOSE,1)<RSI14_Value_Sell_Close) //close sell when rsi is lower than some value
         {
          if(iRSI(NULL,0,14,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,2)) //and RSI is going down
           {
            if(iRSI(NULL,0,5,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,1)) //and rsi5 is higher
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);
           }
         }
       }
     }
   }
 }

return(0);
}

int MaxOrders(int buys, int sells, int type)
{
if(MaxSumOrders>0) return(MaxSumOrders-buys-sells);
if(MaxSumOrders==0) {
 if(type==0) return(MaxBuys);
 if(type==1) return(MaxSells); }
return(99999);
}